#! /bin/bash

#/**********************************************
# *  AOSD 10 Submission Files                  *
# *  perf_results.sh :                         *
# *    Creates a TeX table of timiing results  *
# *                                            *
# *********************************************/

if [ "$1" == "" ]; then
    echo " usage: results.sh <times>"
    exit 1
fi

each=$1
len=$2

function times {

     #echo "scale=2; (($1-$2)*100)/$1" | bc
    echo -n `echo "scale=2; ($1/$2)" | bc`
    echo "x"
}

function perc {

    echo "scale=2; (($1-$2)*100)/$1" | bc
}

typs=( "      Hand" "   Visitor" "  * Inline" "* Parallel" "Reflective" );
thresh=( 2 2 2 2 2 2);
#sizes=( 600 30 300 300 300 300);
sizes=( 1500 1500 1500 1500 1500 1500);
names=( CircsTU ToSVG Scale Circ2sqr Flip Compress );
funcs=( circstu tosvg scale circ2sqr flip compress );

echo -n "   Type     "
for f in 0 1 2 3 4 5; do
    echo -n " & {\tt ${names[$f]} } "
done
echo "\\\\\hline"


for typ in 2 3 0 1; do # 4 5; do
    echo -n "{\\sc  ${typs[$typ]}}"
    for f in 0 1 2 3 4 5; do
        func=${funcs[$f]}
        res=`./perf_average.sh $each "java Timings $func $typ ${sizes[$f]} ${thresh[$f]}"`;
        echo -n " & $res "
    done
    echo "\\\\\hline"
done
echo